function varargout=subsref(a,s)
% https://fr.mathworks.com/help/matlab/matlab_oop/code-patterns-for-subsref-and-subsasgn-methods.html
% b=a(s1,s2,...sn)
%s
  switch s(1).type
    case '.'
      prop = s(1).subs;
      if length(s) == 1 % Implement a.PropertyName
        %prop = s(1).subs;
        varargout{1}=a.(prop);
      else
        if nargout==0
          subsref(a.(prop),s(2:end))
          %builtin('subsref',a.(prop),s(2:end));
        else
          %varargout = {builtin('subsref',a.(prop),s(2:end))};
          varargout = {subsref(a.(prop),s(2:end))};
        end
      end
      return
    case '()' 
      subs=s.subs;
      if length(s) == 1%
        subs=s.subs;
        assert(length(subs)<=3)
        if length(subs)==1 % Implement a(k): return the k-th matrice, 
          if ischar(subs{1}) && subs{1}==':' 
            varargout{1}=a.values(:);  % a(:)
            % force output to be complex even when all imaginary part of elements are 0
            if ~isreal(a.values) && isreal(varargout{1}), varargout{1}=complex(varargout{1});end
            return 
          end
          if isscalar(subs{1})
            varargout{1}=squeeze(a.values(subs{1},:,:));
            % force output to be complex even when all imaginary part of elements are 0
            if ~isreal(a.values) && isreal(varargout{1}), varargout{1}=complex(varargout{1});end
            return
          end
          varargout{1}=amat(a.values(subs{1},:,:));
          % force output to be complex even when all imaginary part of elements are 0
          if ~isreal(a.values) && isreal(varargout{1}), varargout{1}.values=complex(varargout{1}.values);end
          return
        end
        if length(subs)==2 % Implement a(i,j): return a(:,i,j) as an amat object
          if isamat(subs{1}) && isamat(subs{2})  % return a(:,I,J) with I,J amat object with same size and I.N==a.N
            assert( all(size(subs{1})==size(subs{2})) && subs{1}.N==a.N )
            [N,m,n]=size(subs{1});
            K=fc_amat.ones(N,m,n).*[1:N]';
            idx=sub2ind(size(a),K.values,subs{1}.values,subs{2}.values);
            varargout{1}=amat(a.values(idx));
            return
          end
          varargout{1}=amat(a.values(:,subs{1},subs{2}));
          % force output to be complex even when all imaginary part of elements are 0
          if ~isreal(a.values) && isreal(varargout{1}), varargout{1}.values=complex(varargout{1}.values);end
          return
        end
        % length(subs)==3
        if a.nc>1
          if isamat(subs{1}) && isamat(subs{2}) && isamat(subs{3})  % return a(K,I,J) with K,I,J amat object with same size
            assert( all(size(subs{1})==size(subs{2})) && all(size(subs{1})==size(subs{3})) )
            [N,m,n]=size(subs{1});
            idx=sub2ind(size(a),subs{1}.values,subs{2}.values,subs{3}.values);
            varargout{1}=amat(a.values(idx));
            return
          end
          b=a.values(subs{:});
          
          
          
        else
          if length(subs)==3
            if ischar(subs{3})
              assert(strcmp(subs{3},':'))
              %K=1:a.N;
            elseif isscalar(subs{3})
              assert( subs{3}==1 )
            else
              error('Failed with 3-rd parameter')
            end
            b=a.values(subs{1:2});
          else
            b=a.values(subs{:});
          end
        end
        %whos
        if a.nc>1 % Really 3D array
          if size(b,1)==1
            varargout{1}=reshape(b,[size(b,2),size(b,3)]);
          else
            varargout{1}=amat(b);
          end
        else
          if size(b,1)==1
            varargout{1}=b.';
          else
            varargout{1}=amat(b);
          end
        end
      else % Use built-in for any other expression
        if nargout==0
          builtin('subsref',a,s);
        else
          varargout = {builtin('subsref',a,s)};
        end
      end
      % force output to be complex even when all imaginary part of elements are 0
      if ~isreal(a.values) && isreal(varargout{1})
        if isamat(varargout{1})
          varargout{1}.values=complex(varargout{1}.values);
        else
          varargout{1}=complex(varargout{1});
        end
      end      
    otherwise
      error('%s not available with amat object',s(1).type)
  end
end
